diff --git a/gnome-session/gsm-autostart-app.h b/gnome-session/gsm-autostart-app.h
new file mode 100644
index 00000000..91a74a67
--- /dev/null
+++ b/gnome-session/gsm-autostart-app.h
@@ -0,0 +1,59 @@
+/* -*- Mode: C; tab-width: 8; indent-tabs-mode: nil; c-basic-offset: 8 -*-
+ *
+ * Copyright (C) 2007 Novell, Inc.
+ * Copyright (C) 2008 Red Hat, Inc.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation; either version 2 of the
+ * License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ */
+
+#ifndef __GSM_AUTOSTART_APP_H__
+#define __GSM_AUTOSTART_APP_H__
+
+#include "gsm-app.h"
+
+G_BEGIN_DECLS
+
+#define GSM_TYPE_AUTOSTART_APP            (gsm_autostart_app_get_type ())
+G_DECLARE_DERIVABLE_TYPE (GsmAutostartApp, gsm_autostart_app, GSM, AUTOSTART_APP, GsmApp)
+
+struct _GsmAutostartAppClass
+{
+        GsmAppClass parent_class;
+
+        /* signals */
+        void     (*condition_changed)  (GsmApp  *app,
+                                        gboolean condition);
+};
+
+GsmApp *gsm_autostart_app_new                (const char *desktop_file,
+                                              gboolean    mask_systemd,
+                                              GError    **error);
+
+void    gsm_autostart_app_add_provides       (GsmAutostartApp *aapp,
+                                              const char      *provides);
+
+#define GSM_AUTOSTART_APP_SYSTEMD_KEY     "X-GNOME-HiddenUnderSystemd"
+#define GSM_AUTOSTART_APP_ENABLED_KEY     "X-GNOME-Autostart-enabled"
+#define GSM_AUTOSTART_APP_PHASE_KEY       "X-GNOME-Autostart-Phase"
+#define GSM_AUTOSTART_APP_PROVIDES_KEY    "X-GNOME-Provides"
+#define GSM_AUTOSTART_APP_STARTUP_ID_KEY  "X-GNOME-Autostart-startup-id"
+#define GSM_AUTOSTART_APP_AUTORESTART_KEY "X-GNOME-AutoRestart"
+#define GSM_AUTOSTART_APP_DBUS_NAME_KEY   "X-GNOME-DBus-Name"
+#define GSM_AUTOSTART_APP_DBUS_PATH_KEY   "X-GNOME-DBus-Path"
+#define GSM_AUTOSTART_APP_DBUS_ARGS_KEY   "X-GNOME-DBus-Start-Arguments"
+#define GSM_AUTOSTART_APP_DISCARD_KEY     "X-GNOME-Autostart-discard-exec"
+
+G_END_DECLS
+
+#endif /* __GSM_AUTOSTART_APP_H__ */
diff --git a/gnome-session/gsm-client.c b/gnome-session/gsm-client.c
index 7e0e3f20..c8123eab 100644
--- a/gnome-session/gsm-client.c
+++ b/gnome-session/gsm-client.c
@@ -19,32 +19,29 @@
 
 #include "config.h"
 
-#include <gio/gio.h>
-
 #include "gsm-client.h"
-#include "org.gnome.SessionManager.ClientPrivate.h"
-
-struct _GsmClient
-{
-        GObject                   parent_instance;
+#include "org.gnome.SessionManager.Client.h"
 
-        char                     *id;
-        char                     *app_id;
-        char                     *bus_name;
+static guint32 client_serial = 1;
 
-        GPid                      caller_pid;
-
-        GDBusConnection          *connection;
-        GsmExportedClientPrivate *skeleton;
-        guint                     watch_id;
-};
+typedef struct
+{
+        char            *id;
+        char            *startup_id;
+        char            *app_id;
+        guint            status;
+        GsmExportedClient *skeleton;
+        GDBusConnection *connection;
+} GsmClientPrivate;
 
 typedef enum {
-        PROP_0,
+        PROP_STARTUP_ID = 1,
         PROP_APP_ID,
-        PROP_BUS_NAME,
+        PROP_STATUS,
 } GsmClientProperty;
 
+static GParamSpec *props[PROP_STATUS + 1] = { NULL, };
+
 enum {
         DISCONNECTED,
         END_SESSION_RESPONSE,
@@ -53,81 +50,156 @@ enum {
 
 static guint signals[LAST_SIGNAL] = { 0 };
 
-G_DEFINE_TYPE (GsmClient, gsm_client, G_TYPE_OBJECT);
+G_DEFINE_ABSTRACT_TYPE_WITH_PRIVATE (GsmClient, gsm_client, G_TYPE_OBJECT)
+
+#define GSM_CLIENT_DBUS_IFACE "org.gnome.SessionManager.Client"
+
+static const GDBusErrorEntry gsm_client_error_entries[] = {
+        { GSM_CLIENT_ERROR_GENERAL, GSM_CLIENT_DBUS_IFACE ".GeneralError" },
+        { GSM_CLIENT_ERROR_NOT_REGISTERED, GSM_CLIENT_DBUS_IFACE ".NotRegistered" }
+};
+
+GQuark
+gsm_client_error_quark (void)
+{
+        static volatile gsize quark_volatile = 0;
+
+        g_dbus_error_register_error_domain ("gsm_client_error",
+                                            &quark_volatile,
+                                            gsm_client_error_entries,
+                                            G_N_ELEMENTS (gsm_client_error_entries));
+        return quark_volatile;
+}
 
 static guint32
 get_next_client_serial (void)
 {
-        static guint32 next_serial = 1;
         guint32 serial;
 
-        serial = next_serial++;
+        serial = client_serial++;
 
-        if ((gint32)next_serial < 0)
-                next_serial = 1;
+        if ((gint32)client_serial < 0) {
+                client_serial = 1;
+        }
 
         return serial;
 }
 
 static gboolean
-handle_end_session_response (GsmExportedClientPrivate *skeleton,
-                             GDBusMethodInvocation    *invocation,
-                             gboolean                  is_ok,
-                             const char               *reason,
-                             GsmClient                *client)
+gsm_client_get_startup_id (GsmExportedClient     *skeleton,
+                           GDBusMethodInvocation *invocation,
+                           GsmClient             *client)
 {
-        g_debug ("GsmClient(%s): got EndSessionResponse is-ok:%d reason=%s",
-                 client->app_id, is_ok, reason);
+        GsmClientPrivate *priv = gsm_client_get_instance_private (client);
 
-        g_signal_emit (client, signals[END_SESSION_RESPONSE], 0, is_ok, reason);
+        gsm_exported_client_complete_get_startup_id (skeleton, invocation, priv->startup_id);
+        return TRUE;
+}
+
+static gboolean
+gsm_client_get_app_id (GsmExportedClient     *skeleton,
+                       GDBusMethodInvocation *invocation,
+                       GsmClient             *client)
+{
+        GsmClientPrivate *priv = gsm_client_get_instance_private (client);
 
-        gsm_exported_client_private_complete_end_session_response (skeleton, invocation);
+        gsm_exported_client_complete_get_app_id (skeleton, invocation, priv->app_id);
         return TRUE;
 }
 
 static gboolean
-register_client (GsmClient *client)
+gsm_client_get_restart_style_hint (GsmExportedClient     *skeleton,
+                                   GDBusMethodInvocation *invocation,
+                                   GsmClient             *client)
 {
-        g_autoptr (GError) error = NULL;
+        guint hint;
 
-        client->connection = g_bus_get_sync (G_BUS_TYPE_SESSION, NULL, &error);
-        if (error != NULL) {
-                g_critical ("GsmClient: Couldn't connect to session bus: %s",
-                            error->message);
-                return FALSE;
-        }
+        hint = GSM_CLIENT_GET_CLASS (client)->impl_get_restart_style_hint (client);
+        gsm_exported_client_complete_get_restart_style_hint (skeleton, invocation, hint);
+        return TRUE;
+}
+
+static gboolean
+gsm_client_get_status (GsmExportedClient     *skeleton,
+                       GDBusMethodInvocation *invocation,
+                       GsmClient             *client)
+{
+        GsmClientPrivate *priv = gsm_client_get_instance_private (client);
+
+        gsm_exported_client_complete_get_status (skeleton, invocation, priv->status);
+        return TRUE;
+}
+
+static gboolean
+gsm_client_get_unix_process_id (GsmExportedClient     *skeleton,
+                                GDBusMethodInvocation *invocation,
+                                GsmClient             *client)
+{
+        guint pid;
+
+        pid = GSM_CLIENT_GET_CLASS (client)->impl_get_unix_process_id (client);
+        gsm_exported_client_complete_get_unix_process_id (skeleton, invocation, pid);
+        return TRUE;
+}
+
+static gboolean
+gsm_client_stop_dbus (GsmExportedClient     *skeleton,
+                      GDBusMethodInvocation *invocation,
+                      GsmClient             *client)
+{
+        GError *error = NULL;
+        gsm_client_stop (client, &error);
 
-        client->skeleton = gsm_exported_client_private_skeleton_new ();
-        g_debug ("exporting client to object path: %s", client->id);
-        g_dbus_interface_skeleton_export (G_DBUS_INTERFACE_SKELETON (client->skeleton),
-                                          client->connection, client->id, &error);
         if (error != NULL) {
-                g_critical ("GsmClient: error exporting on session bus: %s",
-                            error->message);
-                return FALSE;
+                g_dbus_method_invocation_take_error (invocation, error);
+        } else {
+                gsm_exported_client_complete_stop (skeleton, invocation);
         }
 
-        g_signal_connect (client->skeleton,
-                          "handle-end-session-response",
-                          G_CALLBACK (handle_end_session_response),
-                          client);
-
         return TRUE;
 }
 
-static void
-on_client_vanished (GDBusConnection *connection,
-                    const char      *name,
-                    gpointer         user_data)
+static gboolean
+register_client (GsmClient *client)
 {
-        GsmClient *client = user_data;
+        GsmClientPrivate *priv = gsm_client_get_instance_private (client);
+        GError *error = NULL;
+        GsmExportedClient *skeleton;
+
+        priv->connection = g_bus_get_sync (G_BUS_TYPE_SESSION, NULL, &error);
+        if (priv->connection == NULL) {
+                g_critical ("error getting session bus: %s", error->message);
+                g_error_free (error);
+                return FALSE;
+        }
+
+        skeleton = gsm_exported_client_skeleton_new ();
+        priv->skeleton = skeleton;
+        g_debug ("exporting client to object path: %s", priv->id);
+        g_dbus_interface_skeleton_export (G_DBUS_INTERFACE_SKELETON (skeleton),
+                                          priv->connection,
+                                          priv->id, &error);
 
-        g_bus_unwatch_name (client->watch_id);
-        client->watch_id = 0;
+        if (error != NULL) {
+                g_critical ("error exporting client on session bus: %s", error->message);
+                g_error_free (error);
+                return FALSE;
+        }
 
-        client->caller_pid = 0;
+        g_signal_connect (skeleton, "handle-get-app-id",
+                          G_CALLBACK (gsm_client_get_app_id), client);
+        g_signal_connect (skeleton, "handle-get-restart-style-hint",
+                          G_CALLBACK (gsm_client_get_restart_style_hint), client);
+        g_signal_connect (skeleton, "handle-get-startup-id",
+                          G_CALLBACK (gsm_client_get_startup_id), client);
+        g_signal_connect (skeleton, "handle-get-status",
+                          G_CALLBACK (gsm_client_get_status), client);
+        g_signal_connect (skeleton, "handle-get-unix-process-id",
+                          G_CALLBACK (gsm_client_get_unix_process_id), client);
+        g_signal_connect (skeleton, "handle-stop",
+                          G_CALLBACK (gsm_client_stop_dbus), client);
 
-        g_signal_emit (client, signals[DISCONNECTED], 0);
+        return TRUE;
 }
 
 static GObject *
@@ -135,27 +207,23 @@ gsm_client_constructor (GType                  type,
                         guint                  n_construct_properties,
                         GObjectConstructParam *construct_properties)
 {
+        GsmClientPrivate *priv;
         GsmClient *client;
+        gboolean   res;
 
         client = GSM_CLIENT (G_OBJECT_CLASS (gsm_client_parent_class)->constructor (type,
                                                                                     n_construct_properties,
                                                                                     construct_properties));
+        priv = gsm_client_get_instance_private (client);
 
-        g_free (client->id);
-        client->id = g_strdup_printf ("/org/gnome/SessionManager/Client%u", get_next_client_serial ());
+        g_free (priv->id);
+        priv->id = g_strdup_printf ("/org/gnome/SessionManager/Client%u", get_next_client_serial ());
 
-        if (!register_client (client)) {
+        res = register_client (client);
+        if (! res) {
                 g_warning ("Unable to register client with session bus");
         }
 
-        client->watch_id = g_bus_watch_name (G_BUS_TYPE_SESSION,
-                                             client->bus_name,
-                                             G_BUS_NAME_WATCHER_FLAGS_NONE,
-                                             NULL,
-                                             on_client_vanished,
-                                             client,
-                                             NULL);
-
         return G_OBJECT (client);
 }
 
@@ -164,35 +232,82 @@ gsm_client_init (GsmClient *client)
 {
 }
 
-void
-gsm_client_set_app_id (GsmClient  *client,
-                       const char *app_id)
+static void
+gsm_client_finalize (GObject *object)
 {
-        g_return_if_fail (GSM_IS_CLIENT (client));
+        GsmClient *client;
+        GsmClientPrivate *priv;
+
+        g_return_if_fail (object != NULL);
+        g_return_if_fail (GSM_IS_CLIENT (object));
 
-        if (g_strcmp0 (client->app_id, app_id) == 0)
-                return;
+        client = GSM_CLIENT (object);
+        priv = gsm_client_get_instance_private (client);
+
+        g_return_if_fail (priv != NULL);
+
+        g_free (priv->id);
+        g_free (priv->startup_id);
+        g_free (priv->app_id);
+
+        if (priv->skeleton != NULL) {
+                g_dbus_interface_skeleton_unexport_from_connection (G_DBUS_INTERFACE_SKELETON (priv->skeleton),
+                                                                    priv->connection);
+                g_clear_object (&priv->skeleton);
+        }
 
-        g_free (client->app_id);
-        client->app_id = g_strdup (app_id ?: "");
+        g_clear_object (&priv->connection);
 
-        g_object_notify (G_OBJECT (client), "app-id");
+        G_OBJECT_CLASS (gsm_client_parent_class)->finalize (object);
+}
+
+void
+gsm_client_set_status (GsmClient *client,
+                       guint      status)
+{
+        GsmClientPrivate *priv = gsm_client_get_instance_private (client);
+
+        g_return_if_fail (GSM_IS_CLIENT (client));
+        if (priv->status != status) {
+                priv->status = status;
+                g_object_notify_by_pspec (G_OBJECT (client), props[PROP_STATUS]);
+        }
 }
 
 static void
-gsm_client_set_bus_name (GsmClient  *client,
-                         const char *bus_name)
+gsm_client_set_startup_id (GsmClient  *client,
+                           const char *startup_id)
 {
+        GsmClientPrivate *priv = gsm_client_get_instance_private (client);
+
         g_return_if_fail (GSM_IS_CLIENT (client));
-        g_return_if_fail (bus_name != NULL);
 
-        if (g_strcmp0 (client->bus_name, bus_name) == 0)
-                return;
+        g_free (priv->startup_id);
+
+        if (startup_id != NULL) {
+                priv->startup_id = g_strdup (startup_id);
+        } else {
+                priv->startup_id = g_strdup ("");
+        }
+        g_object_notify_by_pspec (G_OBJECT (client), props[PROP_STARTUP_ID]);
+}
+
+void
+gsm_client_set_app_id (GsmClient  *client,
+                       const char *app_id)
+{
+        GsmClientPrivate *priv = gsm_client_get_instance_private (client);
 
-        g_free (client->bus_name);
-        client->bus_name = g_strdup (bus_name);
+        g_return_if_fail (GSM_IS_CLIENT (client));
 
-        g_object_notify (G_OBJECT (client), "bus-name");
+        g_free (priv->app_id);
+
+        if (app_id != NULL) {
+                priv->app_id = g_strdup (app_id);
+        } else {
+                priv->app_id = g_strdup ("");
+        }
+        g_object_notify_by_pspec (G_OBJECT (client), props[PROP_APP_ID]);
 }
 
 static void
@@ -201,14 +316,19 @@ gsm_client_set_property (GObject       *object,
                          const GValue  *value,
                          GParamSpec    *pspec)
 {
-        GsmClient *self = GSM_CLIENT (object);
+        GsmClient *self;
+
+        self = GSM_CLIENT (object);
 
         switch ((GsmClientProperty) prop_id) {
+        case PROP_STARTUP_ID:
+                gsm_client_set_startup_id (self, g_value_get_string (value));
+                break;
         case PROP_APP_ID:
                 gsm_client_set_app_id (self, g_value_get_string (value));
                 break;
-        case PROP_BUS_NAME:
-                gsm_client_set_bus_name (self, g_value_get_string (value));
+        case PROP_STATUS:
+                gsm_client_set_status (self, g_value_get_uint (value));
                 break;
         default:
                 G_OBJECT_WARN_INVALID_PROPERTY_ID (object, prop_id, pspec);
@@ -223,13 +343,17 @@ gsm_client_get_property (GObject    *object,
                          GParamSpec *pspec)
 {
         GsmClient *self = GSM_CLIENT (object);
+        GsmClientPrivate *priv = gsm_client_get_instance_private (self);
 
         switch ((GsmClientProperty) prop_id) {
+        case PROP_STARTUP_ID:
+                g_value_set_string (value, priv->startup_id);
+                break;
         case PROP_APP_ID:
-                g_value_set_string (value, self->app_id);
+                g_value_set_string (value, priv->app_id);
                 break;
-        case PROP_BUS_NAME:
-                g_value_set_string (value, self->bus_name);
+        case PROP_STATUS:
+                g_value_set_uint (value, priv->status);
                 break;
         default:
                 G_OBJECT_WARN_INVALID_PROPERTY_ID (object, prop_id, pspec);
@@ -237,29 +361,30 @@ gsm_client_get_property (GObject    *object,
         }
 }
 
+static gboolean
+default_stop (GsmClient *client,
+              GError   **error)
+{
+        g_return_val_if_fail (GSM_IS_CLIENT (client), FALSE);
+
+        g_warning ("Stop not implemented");
+
+        return TRUE;
+}
+
 static void
 gsm_client_dispose (GObject *object)
 {
         GsmClient *client;
+        GsmClientPrivate *priv;
 
         g_return_if_fail (object != NULL);
         g_return_if_fail (GSM_IS_CLIENT (object));
-        client = GSM_CLIENT (object);
-
-        g_free (client->id);
-        g_free (client->app_id);
-        g_free (client->bus_name);
-
-        if (client->skeleton != NULL) {
-                g_dbus_interface_skeleton_unexport_from_connection (G_DBUS_INTERFACE_SKELETON (client->skeleton),
-                                                                    client->connection);
-                g_clear_object (&client->skeleton);
-        }
 
-        g_clear_object (&client->connection);
+        client = GSM_CLIENT (object);
+        priv = gsm_client_get_instance_private (client);
 
-        if (client->watch_id != 0)
-                g_bus_unwatch_name (client->watch_id);
+        g_debug ("GsmClient: disposing %s", priv->id);
 
         G_OBJECT_CLASS (gsm_client_parent_class)->dispose (object);
 }
@@ -272,51 +397,60 @@ gsm_client_class_init (GsmClientClass *klass)
         object_class->get_property = gsm_client_get_property;
         object_class->set_property = gsm_client_set_property;
         object_class->constructor = gsm_client_constructor;
+        object_class->finalize = gsm_client_finalize;
         object_class->dispose = gsm_client_dispose;
 
+        klass->impl_stop = default_stop;
+
         signals[DISCONNECTED] =
                 g_signal_new ("disconnected",
                               G_OBJECT_CLASS_TYPE (object_class),
                               G_SIGNAL_RUN_LAST,
-                              0, NULL, NULL, NULL,
+                              G_STRUCT_OFFSET (GsmClientClass, disconnected),
+                              NULL, NULL, NULL,
                               G_TYPE_NONE,
                               0);
         signals[END_SESSION_RESPONSE] =
                 g_signal_new ("end-session-response",
                               G_OBJECT_CLASS_TYPE (object_class),
                               G_SIGNAL_RUN_LAST,
-                              0, NULL, NULL, NULL,
+                              G_STRUCT_OFFSET (GsmClientClass, end_session_response),
+                              NULL, NULL, NULL,
                               G_TYPE_NONE,
-                              2, G_TYPE_BOOLEAN, G_TYPE_STRING);
-
-        g_object_class_install_property (object_class,
-                                         PROP_APP_ID,
-                                         g_param_spec_string ("app-id",
-                                                              "app-id",
-                                                              "app-id",
-                                                              "",
-                                                              G_PARAM_READWRITE | G_PARAM_CONSTRUCT | G_PARAM_STATIC_STRINGS | G_PARAM_EXPLICIT_NOTIFY));
-        g_object_class_install_property (object_class,
-                                         PROP_BUS_NAME,
-                                         g_param_spec_string ("bus-name",
-                                                              "bus-name",
-                                                              "bus-name",
-                                                              NULL,
-                                                              G_PARAM_READWRITE | G_PARAM_CONSTRUCT_ONLY | G_PARAM_STATIC_STRINGS | G_PARAM_EXPLICIT_NOTIFY));
+                              4, G_TYPE_BOOLEAN, G_TYPE_BOOLEAN, G_TYPE_BOOLEAN, G_TYPE_STRING);
+
+        props[PROP_STARTUP_ID] =
+                g_param_spec_string ("startup-id",
+                                     "startup-id",
+                                     "startup-id",
+                                     "",
+                                     G_PARAM_READWRITE | G_PARAM_CONSTRUCT | G_PARAM_STATIC_STRINGS | G_PARAM_EXPLICIT_NOTIFY);
+        props[PROP_APP_ID] =
+                g_param_spec_string ("app-id",
+                                     "app-id",
+                                     "app-id",
+                                     "",
+                                     G_PARAM_READWRITE | G_PARAM_CONSTRUCT | G_PARAM_STATIC_STRINGS | G_PARAM_EXPLICIT_NOTIFY);
+        props[PROP_STATUS] =
+                g_param_spec_uint ("status",
+                                   "status",
+                                   "status",
+                                   0,
+                                   G_MAXINT,
+                                   GSM_CLIENT_UNREGISTERED,
+                                   G_PARAM_READWRITE | G_PARAM_CONSTRUCT | G_PARAM_STATIC_STRINGS | G_PARAM_EXPLICIT_NOTIFY);
+
+        g_object_class_install_properties (object_class, G_N_ELEMENTS (props), props);
 }
 
 const char *
 gsm_client_peek_id (GsmClient *client)
 {
-        g_return_val_if_fail (GSM_IS_CLIENT (client), NULL);
-        return client->id;
-}
+        GsmClientPrivate *priv = gsm_client_get_instance_private (client);
 
-const char *
-gsm_client_peek_bus_name (GsmClient *client)
-{
         g_return_val_if_fail (GSM_IS_CLIENT (client), NULL);
-        return client->bus_name;
+
+        return priv->id;
 }
 
 /**
@@ -332,8 +466,54 @@ gsm_client_peek_bus_name (GsmClient *client)
 const char *
 gsm_client_peek_app_id (GsmClient *client)
 {
+        GsmClientPrivate *priv = gsm_client_get_instance_private (client);
+
+        g_return_val_if_fail (GSM_IS_CLIENT (client), NULL);
+
+        return priv->app_id;
+}
+
+const char *
+gsm_client_peek_startup_id (GsmClient *client)
+{
+        GsmClientPrivate *priv = gsm_client_get_instance_private (client);
+
         g_return_val_if_fail (GSM_IS_CLIENT (client), NULL);
-        return client->app_id;
+
+        return priv->startup_id;
+}
+
+guint
+gsm_client_peek_status (GsmClient *client)
+{
+        GsmClientPrivate *priv = gsm_client_get_instance_private (client);
+
+        g_return_val_if_fail (GSM_IS_CLIENT (client), GSM_CLIENT_UNREGISTERED);
+
+        return priv->status;
+}
+
+guint
+gsm_client_peek_restart_style_hint (GsmClient *client)
+{
+        g_return_val_if_fail (GSM_IS_CLIENT (client), GSM_CLIENT_RESTART_NEVER);
+
+        return GSM_CLIENT_GET_CLASS (client)->impl_get_restart_style_hint (client);
+}
+
+/**
+ * gsm_client_get_app_name:
+ * @client: a #GsmClient.
+ *
+ * Returns: a copy of the application name of the client, or %NULL if no such
+ * name is known.
+ **/
+char *
+gsm_client_get_app_name (GsmClient *client)
+{
+        g_return_val_if_fail (GSM_IS_CLIENT (client), NULL);
+
+        return GSM_CLIENT_GET_CLASS (client)->impl_get_app_name (client);
 }
 
 gboolean
@@ -342,10 +522,7 @@ gsm_client_cancel_end_session (GsmClient *client,
 {
         g_return_val_if_fail (GSM_IS_CLIENT (client), FALSE);
 
-        g_debug ("GsmClient: sending CancelEndSession signal to %s", client->bus_name);
-
-        gsm_exported_client_private_emit_cancel_end_session (client->skeleton);
-        return TRUE;
+        return GSM_CLIENT_GET_CLASS (client)->impl_cancel_end_session (client, error);
 }
 
 
@@ -356,10 +533,7 @@ gsm_client_query_end_session (GsmClient                *client,
 {
         g_return_val_if_fail (GSM_IS_CLIENT (client), FALSE);
 
-        g_debug ("GsmClient: sending QueryEndSession signal to %s", client->bus_name);
-
-        gsm_exported_client_private_emit_query_end_session (client->skeleton, flags);
-        return TRUE;
+        return GSM_CLIENT_GET_CLASS (client)->impl_query_end_session (client, flags, error);
 }
 
 gboolean
@@ -369,10 +543,7 @@ gsm_client_end_session (GsmClient                *client,
 {
         g_return_val_if_fail (GSM_IS_CLIENT (client), FALSE);
 
-        g_debug ("GsmClient: sending EndSession signal to %s", client->bus_name);
-
-        gsm_exported_client_private_emit_end_session (client->skeleton, flags);
-        return TRUE;
+        return GSM_CLIENT_GET_CLASS (client)->impl_end_session (client, flags, error);
 }
 
 gboolean
@@ -381,18 +552,32 @@ gsm_client_stop (GsmClient *client,
 {
         g_return_val_if_fail (GSM_IS_CLIENT (client), FALSE);
 
-        g_debug ("GsmClient: sending Stop signal to %s", client->bus_name);
+        return GSM_CLIENT_GET_CLASS (client)->impl_stop (client, error);
+}
 
-        gsm_exported_client_private_emit_stop (client->skeleton);
-        return TRUE;
+void
+gsm_client_disconnected (GsmClient *client)
+{
+        g_signal_emit (client, signals[DISCONNECTED], 0);
 }
 
-GsmClient *
-gsm_client_new (const char *app_id,
-                const char *bus_name)
+GKeyFile *
+gsm_client_save (GsmClient *client,
+                 GsmApp    *app,
+                 GError   **error)
+{
+        g_return_val_if_fail (GSM_IS_CLIENT (client), NULL);
+
+        return GSM_CLIENT_GET_CLASS (client)->impl_save (client, app, error);
+}
+
+void
+gsm_client_end_session_response (GsmClient  *client,
+                                 gboolean    is_ok,
+                                 gboolean    do_last,
+                                 gboolean    cancel,
+                                 const char *reason)
 {
-        return g_object_new (GSM_TYPE_CLIENT,
-                             "app-id", app_id,
-                             "bus-name", bus_name,
-                             NULL);
+        g_signal_emit (client, signals[END_SESSION_RESPONSE], 0,
+                       is_ok, do_last, cancel, reason);
 }
